/***************************************************************************

    supportware
    Copyright (C) 2001-2008 by c.holzheuer
    c.holzheuer@sourceworx.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

***************************************************************************/


#ifndef DDITEMSYSVAL_H
#define DDITEMSYSVAL_H

#include <dditem.h>

/// dditemsysval: ein item welches systemvariablen (datum, uid etc) enthält
/**

*/

class dditemsysval : public dditem
{

public:

	enum dd_item_sysval
	{
		sysval_time = 1,
    sysval_date,
    sysval_datetime,
    sysval_users,
    sysval_members,
		sysval_guestnick,
    sysval_nickname,    
    sysval_nickmail,
		sysval_version,
    sysval_uid,
		sysval_spacer,
    sysval_starttime,
		sysval_referer,
		sysval_pagetitle,
		sysval_pagetype,
		sysval_acceptterms,
		sysval_mailalert,
		sysval_masterdomain,
		sysval_memberscore,
		sysval_pageloction,
		sysval_groupid,
		sysval_groupname,
		sysval_groupkeys,
		sysval_groupdescription,
		sysval_groupicon,
		sysval_groupiconbig,
		sysval_entryid,
		sysval_subject,
		sysval_domain,
		sysval_breadcrump,
		sysval_navipage,
		sysval_jumplast,
		sysval_vgwort,
		sysval_imageid,
		sysval_imagepath
	};

	dditemsysval();
	dditemsysval( const ddstring& name );
  dditemsysval( size_t mode );
  dditemsysval( const ddstring& name, const ddstring& value, const ddstring& call="", size_t access=0, size_t mode=0 );

  virtual ~dditemsysval();

  // factory aspekt
  virtual dditem*   clone() const;
  virtual void      set_param( const ddstring& call );  
  virtual dd_result flush_content( ddwebpage& pagelet );
	virtual dd_result flush_content( ddwebpage& pagelet, ddstring& target ); 
	 	 
protected:

	virtual void create_value_content( ddwebpage& pagelet );
	
	size_t  	_mode;
	
};


/***************************************************************************

    supportware
    Copyright (C) 2001-2008 by c.holzheuer
    c.holzheuer@sourceworx.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

***************************************************************************/



/// dditemselect: ein item welches systemvariablen (datum, uid etc) enthält
/**

*/

class dditemselect : public dditem
{

public:

	dditemselect();
	dditemselect( const ddstring& name );
  dditemselect( size_t mode );
  dditemselect( const ddstring& name, const ddstring& value, const ddstring& call="", size_t access=0 );

  virtual ~dditemselect();

  // factory aspekt
  dditem*   clone() const;
  dd_result flush_content( ddwebpage& pagelet );
	dd_result flush_content( ddwebpage& pagelet, ddstring& target ); 

};








#endif
